﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace Deleter
{
    public static class FilterApplicator
    {

        /// <summary>
        /// Copy / paste of below method.  Don't know how I could combine them.
        /// </summary>
        public static IEnumerable<FileInfo> Apply( IEnumerable<FileInfo> files, AppParams appParams )
        {
            // There's always a date filter
            var result = files.FilterByDate( appParams.Cutoff.Value );

            if ( appParams.GuidMode )
            {
                result = result.FilterByNameIsGuid();
            }

            if ( appParams.NumericMode )
            {
                result = result.FilterByThoseBeginningWithNumeric();
            }

            return result;
        }

        /// <summary>
        /// Copy / paste of above method.  Don't know how I could combine them.
        /// </summary>
        public static IEnumerable<string> Apply( IEnumerable<string> folders, AppParams appParams )
        {
            // There's always a date filter
            var result = folders.FilterByDate( appParams.Cutoff.Value );

            if ( appParams.GuidMode )
            {
                result = result.FilterByNameIsGuid();
            }

            if ( appParams.NumericMode )
            {
                result = result.FilterByThoseBeginningWithNumeric();
            }

            return result;
        }

    }
}
